{% load static %}
<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm"
        crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.3.1.js" integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60="
        crossorigin="anonymous"></script>
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.css">
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/plug-ins/1.10.19/dataRender/ellipsis.js"></script>
    <link rel="stylesheet" href="{% static 'css/new.css' %}">
    <title>Books</title>
</head>

<body>

    <div id="body1">
        <div class="container">

            &nbsp;
            <h2 style="text-align:center">My Libray</h2>
            &nbsp;
            <h3 style="text-align:center">★: <span id="favorite-count"></span> Favorites</h3>

            <form method="POST" action='{% url "show_books" %}'>
                {% csrf_token %}
                <div class="form-group">
                  <label for="type_books">Search for type of books:</label>
                  <input type="text" class="form-control" id="type_books" name="type_books">
                </div>
            </form>

            <table id="list_books" class="table table-striped table-bordered dt-responsive" style="width:100%">
                <thead>
                    <tr>
                        <th>id</th>
                        <th>books_image</th>
                        <th>title</th>
                        <th>authors</th>
                        <th>publishers</th>
                        <th>publish date</th>
                        <th>categories</th>
                        <th>Add to favorites</th>
                    </tr>
                </thead>
                <tbody></tbody>
            </table>

        </div>
    </div>

        
</body>

<script type="text/javascript">
// datatables plugin for render books in table
    $(document).ready(function () {
        $('#list_books').DataTable({
            "processing": true,
            "scrollX": true,
            "ajax": {
                "url": '{% url "data_books" %}',
            },

            "lengthMenu": [5, 10, 25, 50],

            "columns": [

                {
                    data: "id",
                    defaultContent: "<i>unknown data<i>"
                },

                {
                    // image thumbnail
                    data: null,
                    render: function (data, type, row, meta) {
                        return '<img src=' + data.volumeInfo.imageLinks.smallThumbnail + '>'

                    }
                },

                {
                    data: "volumeInfo.title",
                    defaultContent: "<i>unknown data<i>"
                },
                {
                    data: "volumeInfo.authors[,]",
                    defaultContent: "<i>unknown data<i>"
                },
                {
                    data: "volumeInfo.publisher",
                    defaultContent: "<i>unknown data<i>"

                },
                {
                    data: "volumeInfo.publishedDate",
                    defaultContent: "<i>unknown data<i>"
                },
                {
                    data: "volumeInfo.categories",
                    defaultContent: "<i>unknown data<i>"
                },
                {
                    orderable: false,
                    data: null,

                    // passing data id
                    render: function (data, type, row, meta) {
                        return "<p class='favorite star-symbol' style='font-size:50px; text-align:center; cursor: pointer '>"+"☆"+"</p>"
                    }

                }

            ],
            "columnDefs": [

                {
                    targets: 0,
                    visible: false,
                    searchable: false
                },
            ],
        });
        // thank you cloud for giving me the star pict :)
        var count_books = localStorage.getItem('favorite-count');

        if (count_books === null) {
            count_books = 0;
        }

        
        update_favorite();

        $(document).on('click', '.favorite', function () {
            if ($(this).text() == "☆") {
                count_books++;
                update_favorite();
                $(this).text("★").css('color','yellow');
            } else {
                count_books--;
                update_favorite();
                $(this).text("☆");
            }
        });

        localStorage.setItem('favorite-count', count_books);

        function update_favorite() {
            document.getElementById('favorite-count').innerHTML = count_books;
        };

    });
</script>

</html>
